<template>
	<div class="mod-config">
		<el-form :inline="true" :model="dataForm" @keyup.enter.native="getDataList()">
			<el-form-item>
				<el-select v-model="dataForm.lineId" :placeholder="'产线'" clearable>
					<el-option v-for="line in lineList" :key="line.code" :value="line.id" :label="line.name" />
				</el-select>
			</el-form-item>
			<el-form-item>
				<el-select v-model="dataForm.equipmentId" :placeholder="'设备名称'" clearable>
					<el-option v-for="eq in eqList" :key="eq.code" :value="eq.id" :label="eq.name" />
				</el-select>
			</el-form-item>
			<el-form-item>
				<el-button @click="getDataList()">{{ $t('query') }}</el-button>
				<!-- <el-button v-if="$hasPermission('monitoring:equipmentgroup:save')" type="primary" @click="addOrUpdateHandle()">{{ $t('add') }}</el-button> -->
			</el-form-item>
		</el-form>

		<base-table :data="dataList" :table-head-configs="tableConfigs" :max-height="calcMaxHeight(8)" @operate-event="handleOperations" @refreshDataList="getDataList" />
		<el-pagination
			@size-change="sizeChangeHandle"
			@current-change="currentChangeHandle"
			:current-page="pageIndex"
			:page-sizes="[10, 20, 50, 100]"
			:page-size="pageSize"
			:total="totalPage"
			layout="total, sizes, prev, pager, next, jumper"
		>
		</el-pagination>
		<!-- 弹窗, 新增 / 修改 -->
		<add-or-update v-if="addOrUpdateVisible" ref="addOrUpdate" :configs="addOrUpdateConfigs" @refreshDataList="getDataList" @destory-dialog="addOrUpdateVisible = false" />
	</div>
</template>

<script>
import { calcMaxHeight } from '@/utils'
import { timeFilter } from '@/utils/filters'
import AddOrUpdate from '@/components/base-dialog/addOrUpdate'
// import AddOrUpdate from './equipmentGroup-add-or-update'
import i18n from '@/i18n'
import BaseTable from '@/components/base-table'
// import TableOperateComponent from '@/components/base-table/components/operationComponent'
import TableTextComponent from '@/components/base-table/components/detailComponent'

const tableConfigs = [
	{
		type: 'index',
		name: i18n.t('index')
	},
	{ prop: 'equipmentName', name: i18n.t('realtime.eqName') },
	{ prop: 'equipmentCode', name: i18n.t('realtime.eqCode') },
	{ prop: 'inputNum', name: i18n.t('realtime.input') },
	{ prop: 'outputNum', name: i18n.t('realtime.output') },
	{
		prop: 'run',
		name: i18n.t('realtime.runState'),
		filter: val => {
			if (val !== null && val !== undefined) return val ? '是' : '否'
		}
	},
	{
		prop: 'status',
		name: i18n.t('realtime.state'),
		filter: val => {
			if (val !== null && val !== undefined) return ['正常', '计划停机', '故障'][+val]
		}
	},
	{
		prop: 'error',
		name: i18n.t('realtime.hasFault'),
		filter: val => {
			if (val !== null && val !== undefined) return val ? '是' : '否'
		}
	},
	{ prop: 'quantityTime', name: i18n.t('realtime.productionSnapshotTime'), filter: timeFilter },
	{ prop: 'statusTime', name: i18n.t('realtime.statusSnapshotTime'), filter: timeFilter },
	{ prop: 'alarm', name: i18n.t('realtime.recentParamValue'), buttonContent: i18n.t('realtime.view'), subcomponent: TableTextComponent, actionName: 'view-alarm' }
	// { prop: 'operations', name: i18n.t('handle'), fixed: 'right', width: 180, subcomponent: TableOperateComponent, options: ['edit', 'delete'] }
]

const addOrUpdateConfigs = {
	type: 'dialog',
	infoUrl: '/monitoring/equipmentGroup',
	fields: [{ name: 'name', label: i18n.t('eq.groupname') }, { name: 'code', label: i18n.t('eq.groupcode') }, 'remark'],
	operations: [
		{ name: 'cancel', showAlways: true },
		{ name: 'save', url: '/monitoring/equipmentGroup', permission: 'monitoring:equipmentgroup:save', showOnEdit: false },
		{ name: 'update', url: '/monitoring/equipmentGroup', permission: 'monitoring:equipmentgroup:update', showOnEdit: true }
	]
}

export default {
	data() {
		return {
			addOrUpdateConfigs,
			calcMaxHeight,
			tableConfigs,
			dataForm: {
				equipmentId: '',
				lineId: ''
			},
			dataList: [],
			eqList: [],
			lineList: [],
			pageIndex: 1,
			pageSize: 10,
			totalPage: 0,
			dataListLoading: false,
			dataListSelections: [],
			addOrUpdateVisible: false
		}
	},
	components: {
		AddOrUpdate,
		BaseTable
	},
	activated() {
		this.getEqList()
		this.getLineList()
		this.getDataList()
	},
	methods: {
		// 设备
		getEqList() {
			this.$http({
				url: this.$http.adornUrl('/monitoring/equipment/page'),
				method: 'get'
			}).then(({ data }) => {
				if (data && data.code === 0) {
					this.eqList = data.data.list
				} else {
					this.eqList = []
				}
			})
		},
		// 产线
		getLineList() {
			this.$http({
				url: this.$http.adornUrl('/monitoring/productionLine/list'),
				method: 'get'
			}).then(({ data }) => {
				if (data && data.code === 0) {
					this.lineList = data.data
				} else {
					this.lineList = []
				}
			})
		},
		// 获取数据列表
		getDataList() {
			this.addOrUpdateVisible = false
			this.dataListLoading = true
			this.$http({
				url: this.$http.adornUrl('/monitoring/equipmentValueMonitor/realTimePage'),
				method: 'get',
				params: this.$http.adornParams({
					page: this.pageIndex,
					limit: this.pageSize,
					equipmentId: this.dataForm.equipmentId,
					lineId: this.dataForm.lineId
				})
			}).then(({ data }) => {
				if (data && data.code === 0) {
					this.dataList = data.data.list
					this.totalPage = data.data.total
				} else {
					this.dataList = []
					this.totalPage = 0
				}
				this.dataListLoading = false
			})
		},
		// 每页数
		sizeChangeHandle(val) {
			this.pageSize = val
			this.pageIndex = 1
			this.getDataList()
		},
		// 当前页
		currentChangeHandle(val) {
			this.pageIndex = val
			this.getDataList()
		},
		// 多选
		selectionChangeHandle(val) {
			this.dataListSelections = val
		},
		handleOperations({ type, data: id }) {
			switch (type) {
				case 'view-alarm':
					const { name, code } = this.dataList.find(item => item.id === id)
					this.$router.push({
						name: 'monitoring-equipmentGroupAlarm',
						params: {
							groupName: name,
							groupCode: code,
							id
						}
					})
					break
				case 'edit':
					return this.addOrUpdateHandle(id)
				case 'delete':
					return this.deleteHandle(id)
			}
		},
		// 新增 / 修改
		addOrUpdateHandle(id) {
			this.addOrUpdateVisible = true
			this.$nextTick(() => {
				this.$refs.addOrUpdate.init(id)
			})
		},
		// 删除
		deleteHandle(id) {
			var ids = id
				? [id]
				: this.dataListSelections.map(item => {
						return item.id
				  })
			this.$confirm(`${i18n.t('prompt.info', { handle: id ? i18n.t('delete').toLowerCase() : i18n.t('deleteBatch').toLowerCase() })}`, i18n.t('prompt.title'), {
				confirmButtonText: i18n.t('confirm'),
				cancelButtonText: i18n.t('cancel'),
				type: 'warning'
			}).then(() => {
				this.$http({
					url: this.$http.adornUrl('/monitoring/equipmentGroup'),
					method: 'delete',
					data: this.$http.adornData(ids, false, 'raw')
				}).then(({ data }) => {
					if (data && data.code === 0) {
						this.$message({
							message: i18n.t('prompt.success'),
							type: 'success',
							duration: 1500,
							onClose: () => {
								this.getDataList()
							}
						})
					} else {
						this.$message.error(data.msg)
					}
				})
			})
		}
	}
}
</script>
